## asterisk-certified 16.8-cert14

=== debian/changelog ===
asterisk-certified (16.8-cert14-1bit1) unstable; urgency=medium

  * New upstream release.

 -- Daniel Betschart <daniel.betschart@betschart-it.ch>  Fri, 24 Jun 2022 10:25:28 +0200

asterisk-certified (16.8-cert13-1bit1) unstable; urgency=medium

  * New upstream release.

 -- Daniel Betschart <daniel.betschart@betschart-it.ch>  Mon, 21 Mar 2022 16:07:14 +0100

asterisk-certified (16.8-cert12-0bit1) unstable; urgency=medium

  * New upstream release.

 -- Daniel Betschart <daniel.betschart@betschart-it.ch>  Sat, 30 Oct 2021 17:17:45 +0200

asterisk-certified (16.8-cert11-0bit1) unstable; urgency=medium

  * New upstream release.

 -- Daniel Betschart <daniel.betschart@betschart-it.ch>  Mon, 16 Aug 2021 16:18:15 +0200

asterisk-certified (16.8-cert7-0bit3) unstable; urgency=medium

  * Built without sound files, Recommends asterisk-cert-moh-opsound-wav instead. Sound
    files are installed by FreePBX automatically.

 -- Daniel Betschart <daniel.betschart@betschart-it.ch>  Fri, 04 Jun 2021 15:37:24 +0200

asterisk-certified (16.8-cert7-0bit2) unstable; urgency=medium

  * Renamed service from asterisk-cert to asterisk.
  * Bump debhelper compat to v12.
  * Using debhelper-compat B-D.

 -- Daniel Betschart <daniel.betschart@betschart-it.ch>  Fri, 30 Apr 2021 20:50:46 +0200

asterisk-certified (16.8-cert7-0bit1) unstable; urgency=medium

  * Initial release.
  * Removed configure parameter --without-pwlib, it does not exists.
  * Enabled codecs: mp3, iLBC
  * Enabled external codecs: opus, silk, siren7, siren14

 -- Daniel Betschart <daniel.betschart@betschart-it.ch>  Mon, 22 Mar 2021 17:09:10 +0100
