=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Starting with dpkg-dev >= 1.16.1.1 you can use the new buildflags.mk file
# to set all *FLAGS
# When building programs that handle untrusted data
# (parsers, network listeners, etc.),
#  or run with elevated privileges (PAM, X, etc.),
#  please enable "PIE" and "BINDNOW" in the build.
#  The "all" option enables "PIE" and "BINDNOW" and future hardening flags

%:
	dh $@

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# Sanity check for a stable release:
SAVED_ABI_HASH = 1fb7f5c06d7a2052e38d021b3d8ca151

export DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
  confflags += --build $(DEB_HOST_GNU_TYPE)
else
  confflags += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif

# We copy around a number of things in case we're linux:
BUILD_OS=$(shell dpkg-architecture -qDEB_BUILD_ARCH_OS)

export PROC := $(shell dpkg-architecture -qDEB_BUILD_GNU_CPU)

# don't let asterisk mess with build flags
BUILDFLAGS += AST_FORTIFY_SOURCE= DEBUG= OPTIMIZE=

# show full gcc arguments instead of [CC] and [LD]
BUILDFLAGS += NOISY_BUILD=yes

BUILDFLAGS += ASTDATADIR=/var/lib/asterisk ASTVARRUNDIR=/run/asterisk

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	ENABLE_DEBUG += --enable-dev-mode
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

include /usr/share/dpkg/pkg-info.mk
DEBVERSION:=$(DEB_VERSION)
DEB_NOEPOCH_VERSION:=$(shell echo $(DEBVERSION) | cut -d':' -f 2)

# make sure we have 'fetch' . We need to have either wget or fetch
# on the system. However it is generally not a good idea to actually
# get remote tarballs at build time. So if neither wget nor fetch
# happen to be installed, the configure script will find a dummy
# fetch script that always returns an error.
FETCH_ENV = PATH=$$PATH:$(CURDIR)/debian/dummyprogs

# resolve if release is experimental
EXP_RELEASE := $(if $(shell dpkg-parsechangelog | grep '^Distribution: \(experimental\|UNRELEASED\)'),exp)

override_dh_autoreconf:
	if [ ! -r configure.debian_sav -a -r configure ]; then cp -a configure configure.debian_sav; fi
	[ -f .version.debian_sav ] || cp -a .version .version.debian_sav
	echo $(DEB_NOEPOCH_VERSION) > .version
	dh_autoreconf -- ./bootstrap.sh

# Make sure the configure script gets an CFLAGS parameter. Otherwise
# it will build with -march=native
# Pass CPPFLAGS in the CFLAGS as otherwise the build system will
# ignore them.
override_dh_auto_configure:
	chmod 755 $(CURDIR)/debian/dummyprogs/fetch
	$(FETCH_ENV) ./configure			\
		CFLAGS="-fgnu89-inline $(CFLAGS) $(CPPFLAGS)" LDFLAGS="$(LDFLAGS) -Wl,--as-needed" \
		--host=$(DEB_HOST_GNU_TYPE)		\
		--build=$(DEB_BUILD_GNU_TYPE)		\
		--prefix=/usr				\
		--mandir=\$${prefix}/share/man		\
		--infodir=\$${prefix}/share/info	\
		--disable-asteriskssl			\
		--with-gsm				\
		--with-imap=system			\
		--with-jansson-bundled			\
		--with-pjproject-bundled		\
		$(if $(EXP_RELEASE),,--without-sdl) \
		${ENABLE_DEBUG} || { cat config.log; exit 1; }


override_dh_auto_build:
	$(MAKE) menuselect.makeopts BUILD_CFLAGS="$(CFLAGS) $(CPPFLAGS)" BUILD_LDFLAGS="$(LDFLAGS)"
	menuselect/menuselect --enable app_macro menuselect.makeopts
#	Codec Translators
#	menuselect/menuselect --enable codec_codec2 menuselect.makeopts

#	Codec Translators External
#	menuselect/menuselect --enable codec_opus_open_source menuselect.makeopts
	menuselect/menuselect --enable codec_opus menuselect.makeopts
	menuselect/menuselect --enable codec_silk menuselect.makeopts
	menuselect/menuselect --enable codec_siren7 menuselect.makeopts
	menuselect/menuselect --enable codec_siren14 menuselect.makeopts

#	Format Interpreters
	menuselect/menuselect --enable format_ogg_speex menuselect.makeopts
	menuselect/menuselect --enable format_vox menuselect.makeopts
	menuselect/menuselect --enable format_mp3 menuselect.makeopts

#	enable non-core modules
#	Applications
	menuselect/menuselect --enable app_alarmreceiver menuselect.makeopts
	menuselect/menuselect --enable app_amd menuselect.makeopts
	menuselect/menuselect --enable app_attended_transfer menuselect.makeopts
	menuselect/menuselect --enable app_blind_transfer menuselect.makeopts
	menuselect/menuselect --enable app_chanisavail menuselect.makeopts
	menuselect/menuselect --enable app_dictate menuselect.makeopts
	menuselect/menuselect --enable app_externalivr menuselect.makeopts
	menuselect/menuselect --enable app_festival menuselect.makeopts
	menuselect/menuselect --enable app_jack menuselect.makeopts
	menuselect/menuselect --enable app_minivm menuselect.makeopts
	menuselect/menuselect --enable app_morsecode menuselect.makeopts
	menuselect/menuselect --enable app_mp3 menuselect.makeopts
	menuselect/menuselect --enable app_sms menuselect.makeopts
	menuselect/menuselect --enable app_test menuselect.makeopts
	menuselect/menuselect --enable app_waitforring menuselect.makeopts
	menuselect/menuselect --enable app_waitforsilence menuselect.makeopts
	menuselect/menuselect --enable app_zapateller menuselect.makeopts
	menuselect/menuselect --enable app_adsiprog menuselect.makeopts
	menuselect/menuselect --enable app_dahdiras menuselect.makeopts
	menuselect/menuselect --enable app_getcpeid menuselect.makeopts
	menuselect/menuselect --enable app_ices menuselect.makeopts
	menuselect/menuselect --enable app_image menuselect.makeopts
	menuselect/menuselect --enable app_nbscat menuselect.makeopts
	menuselect/menuselect --enable app_url menuselect.makeopts

#	CDR
	menuselect/menuselect --enable cdr_csv menuselect.makeopts
	menuselect/menuselect --enable cdr_odbc menuselect.makeopts
	menuselect/menuselect --enable cdr_pgsql menuselect.makeopts
	menuselect/menuselect --enable cdr_radius menuselect.makeopts
	menuselect/menuselect --enable cdr_sqlite3_custom menuselect.makeopts
	menuselect/menuselect --enable cdr_tds menuselect.makeopts

#	CEL
	menuselect/menuselect --enable cel_pgsql menuselect.makeopts
	menuselect/menuselect --enable cel_radius menuselect.makeopts
	menuselect/menuselect --enable cel_sqlite3_custom menuselect.makeopts
	menuselect/menuselect --enable cel_tds menuselect.makeopts

#	Channel Drivers
	menuselect/menuselect --enable chan_alsa menuselect.makeopts
	menuselect/menuselect --enable chan_console menuselect.makeopts
	menuselect/menuselect --enable chan_mgcp menuselect.makeopts
	menuselect/menuselect --enable chan_sip menuselect.makeopts
	menuselect/menuselect --enable chan_skinny menuselect.makeopts
	menuselect/menuselect --enable chan_unistim menuselect.makeopts
	menuselect/menuselect --enable chan_oss menuselect.makeopts
	menuselect/menuselect --enable chan_phone menuselect.makeopts
	menuselect/menuselect --enable chan_vpb menuselect.makeopts

#	Dialplan Functions
	menuselect/menuselect --enable func_frame_trace menuselect.makeopts
	menuselect/menuselect --enable func_pitchshift menuselect.makeopts

#	PBX Modules
	menuselect/menuselect --enable pbx_ael menuselect.makeopts
	menuselect/menuselect --enable pbx_dundi menuselect.makeopts
	menuselect/menuselect --enable pbx_lua menuselect.makeopts
	menuselect/menuselect --enable pbx_realtime menuselect.makeopts

#	Resource Modules
	menuselect/menuselect --enable res_timing_pthread menuselect.makeopts
	menuselect/menuselect --enable res_phoneprov menuselect.makeopts
#	menuselect/menuselect --enable res_pjsip menuselect.makeopts
	menuselect/menuselect --enable res_pjsip_history menuselect.makeopts
	menuselect/menuselect --enable res_pjsip_phoneprov_provider menuselect.makeopts
	menuselect/menuselect --enable res_hep menuselect.makeopts
	menuselect/menuselect --enable res_hep_pjsip menuselect.makeopts
	menuselect/menuselect --enable res_hep_rtcp menuselect.makeopts

#	Debug Functions
	@if [ "x${ENABLE_DEBUG}" != "x" ] ; then \
