=== debian/watch ===
# run "uscan --report" to check or "gpb import-orig --uscan" to update

# opts="repack,compression=xz,dversionmangle=s/~dfsg\d*$//,repacksuffix=~dfsg,pgpsigurlmangle=s/$/.asc/" \

version=4
	opts="repack,compression=xz,pgpsigurlmangle=s/$/.asc/" \
	https://downloads.asterisk.org/pub/telephony/certified-asterisk/releases/asterisk-certified-(16.[0-9.*]-cert[0-9][0-9]).tar.gz debian uupdate
